<template>

	<!-- 不分页的时候用，没有封装 auto 首次使用需要自己在onload里调用 -->
	<!-- 页面的几种状态 0 loading 1 错误 2正常 -->
	<loading-state ref="pageView" @request="request">

		<view>
			<image src="../../static/edit_bg.png" style="width: 100%;height: 40vw;z-index: 0;"></image>
			<view style="display: flex;flex-direction: column;margin-top: -40vw;">
				<view style="display: flex;flex-direction: row;justify-content: space-between;align-items: center;">
					<view style="flex: 1;display: flex;flex-direction: column;z-index: 1;margin-left: 15px;">
						<view style="font-size: 17px;color: #FFFFFF;height: 8vw;line-height: 8vw;margin-top: 5vw;">
							{{data.state}}
						</view>
						<view
							style="font-size: 12px;color: white;line-height: 7vw;height: 7vw;color: #f1f2f3;box-sizing: border-box;">
							{{data.name}}
						</view>
						<view style="font-size: 12px;color: white;line-height: 4vw;height: 4vw;color: #f1f2f3;">
							{{data.time}}
						</view>
					</view>
					<image src='../../static/gift2.png'
						style="width: 40px;height: 40px;padding-right: 30px;flex-shrink: 0;">
					</image>
				</view>

				<view
					style="background: #FFFFFF;border-radius: 20rpx;z-index: 1;min-height: 14vw;margin-left: 15px;margin-right: 15px;margin-top: 4vw;">
					<view style="display: flex;align-items: center;margin-top: 8px;">
						<text style="flex-shrink: 0;font-size: 13px;margin-left: 10px;">提货地点</text>
						<view
							style="display: flex;flex-direction: row;justify-content: space-between;width: 100%;border: 1px solid #EBEEF5;border-radius: 4px;min-height: 35px;margin: 0px 10px;align-items: center;"
							@click="address">
							<view v-if="stringIsEmpty(data.addressName)"
								style="color: #666;font-size: 12px;margin-left: 10px;">请选择提货点</view>
							<view v-if="stringIsNotEmpty(data.addressName)"
								style="color: #666;font-size: 12px;margin-left: 10px;">{{data.addressName}}</view>
							<uni-icons type="bottom" size="14" color="#999"
								style="flex-direction: 0;margin: 0px 5px;" />
						</view>
					</view>
					<view
						style="display: flex;align-items: center;padding-right: 10px;margin-top: 6px;margin-bottom: 8px;">
						<text style="flex-shrink: 0;font-size: 13px;margin-left: 10px;margin-right: 10px;">提货时间</text>
						<uni-datetime-picker type="date" v-model="data.reserveDate" style="flex: 1;" :start="data.start"
							:end="data.end" @showing='showing' />
					</view>
					<view
						style="display: flex;align-items: center;padding-right: 10px;margin-top: 6px;margin-bottom: 8px;">
						<text style="flex-shrink: 0;font-size: 13px;margin-left: 10px;margin-right: 10px; "
							decode="true">提&ensp;货&ensp;人</text>
						<input placeholder="请输入提货人"
							style="font-size: 30rpx;flex: 1;background: #F8F8F8;border-radius: 5px;height: 40px;line-height: 40px;padding-left: 10px;"
							:value="data.userName" @input="onKeyInput1" />
					</view>
					<view
						style="display: flex;align-items: center;padding-right: 10px;margin-top: 6px;margin-bottom: 8px;">
						<text style="flex-shrink: 0;font-size: 13px;margin-left: 10px;margin-right: 10px;">联系电话</text>
						<input maxlength="11" placeholder="请输入联系电话"
							style="font-size: 30rpx;flex: 1;background: #F8F8F8;border-radius: 5px;height: 40px;line-height: 40px;padding-left: 10px;"
							type="number" :value="data.userPhone" @input="onKeyInput2" />
					</view>
				</view>


				<view style="background: #FFFFFF;border-radius: 20rpx;padding: 15px;margin: 10px 15px;">

					<view
						style="display: flex;flex-direction: row;align-items: center;border-bottom: 1rpx #f1f2f3 solid;padding-bottom: 10px;">
						<image src="../../static/mingxi.png" style="width: 15px;height: 15px;"></image>
						<view style="margin-left: 10px;font-size: 14px;">商品明细</view>
					</view>
					<view v-for="(item,index) in data.goodsVos" @click="itemClick(item.goodsSid)"
						style="display: flex;flex-direction: row;margin-top: 15px;">
						<image :src="item.pic" style="width: 60px;height: 60px;flex-shrink: 0;"></image>
						<view
							style="margin-left: 10px;margin-right: 10px;flex: 1;display: flex;flex-direction: column;justify-content: space-between;align-items: flex-end;">
							<text class="text" style="font-weight: 500;width: 100%;">{{item.goods}}
							</text>
							<text class="text"
								style="width: 100%;font-size: 12px; color: #666666;margin-top: 10px;">{{item.remarks}}
							</text>
							<uni-number-box ref="box" style="margin-top: -25px;" :min="0" :max="item.lnum"
								v-model="item.select" :showTextView="page.showTextView"></uni-number-box>
						</view>
					</view>
				</view>
			</view>

			<view style="height: 60px;"></view>
			<view v-if="data.showBtn||data.showRecord"
				style="position: fixed;bottom: 0;height: 50px;background: #f3f4f6;border-top: 1rpx #cacaca solid;width: 100%;display: flex;flex-direction: row;box-sizing: border-box;align-items: center;padding-right: 15px;">
				<view style="flex: 1;"></view>
				<view v-if="data.showRecord" class="btn" style="flex-shrink: 0;color: #191919;" @click="save">
					提交预约</view>
			</view>
		</view>

	</loading-state>
</template>

<script>
	export default {
		data() {
			return {
				page: {
					sid: '',
					showTextView: false
				},
				data: {
					time: "",
					name: "",
					pname: "",
					state: "",
					showBtn: false,
					showRecord: false,
					goodsVos: [],
					value: "",
					select: [],
					userName: "",
					userPhone: "",
				}
			}
		},
		onLoad(options) {
			this.page.sid = options.sid
			this.request()
			uni.$on("address", (e) => {
				// 相当与下拉刷新
				this.data.value = e.sid;
				this.data.addressName = e.name;
			})
		},
		onUnload() {
			uni.$off('address');
		},
		methods: {
			address() {
				uni.navigateTo({
					url: '/pages/SelectAddressActivity'
				})
			},
			onKeyInput1: function(event) {
				this.data.userName = event.target.value
			},
			onKeyInput2: function(event) {
				this.data.userPhone = event.target.value
			},
			showing(e) {
				this.page.showTextView = e
			},
			request() {
				let _this = this
				_this.$api.cardBooking(this.page.sid).then((resp) => {
					_this.data = resp
					// 成功 2
					_this.$nextTick(() => {
						_this.$refs.pageView.setLoadState(2)
					})
				}).catch(e => {
					// 错误 1
					_this.$nextTick(() => {
						_this.$refs.pageView.setLoadState(1)
					})
				})
			},
			save() {
				if (this.stringIsEmpty(this.data.value)) {
					this.shortToast('请选择提货地点')
					return
				}
				if (this.stringIsEmpty(this.data.reserveDate)) {
					this.shortToast('请选择提货时间')
					return
				}
				if (this.stringIsEmpty(this.data.userName)) {
					this.shortToast('请输入提货人员')
					return
				}
				if (this.stringIsEmpty(this.data.userPhone)) {
					this.shortToast('请输入手机号码')
					return
				}
				if (this.data.userPhone.length != 11) {
					this.shortToast('手机号码格式不对')
					return
				}


				let num = 0;
				for (var i = 0; i < this.data.goodsVos.length; i++) {
					num += Number(this.data.goodsVos[i].select);
				}
				if (num == 0) {
					this.shortToast('您未选择任何商品')
					return
				}

				let _this = this
				_this.$api.cardBookingSave(this.data).then((resp) => {
					uni.navigateBack()
					uni.$emit('order', {})
					uni.$emit('order2', {})
				}).catch(e => {
					_this.shortToast('发生异常')
				})

			},
			itemClick(goodsSid) {
				uni.navigateTo({
					url: '/pages/good/goodsDetail?sid=' + goodsSid
				})
			}
		}
	}
</script>

<style>
	.text {
		white-space: normal;
		text-overflow: -o-ellipsis-lastline;
		overflow: hidden;
		text-overflow: ellipsis;
		display: -webkit-box;
		-webkit-line-clamp: 2;
		line-clamp: 2;
		-webkit-box-orient: vertical;
	}

	uni-page-body,
	page {
		background: #F1F2F3;
	}

	.btn {
		border: 1px solid;
		padding-left: 30rpx;
		padding-right: 30rpx;
		padding-top: 12rpx;
		padding-bottom: 12rpx;
		border-radius: 50rpx;
		height: 15px;
		margin-left: 25rpx;
		font-size: 26rpx;
	}
</style>